;-------------------------Artifact PLM 1.7-----------------------------

;Credits to Smiley, Tundain, Nodever2 and Oi27 for constructive criticism/advice/feedback.
;Oi27 and Nodever2 with Labels specifically
;Oi27, the Lore PLM was used for reference/template with the PLM GFX
;MetroidNerd9001 and P.JBoy for getting the earthquake sound

;Version 1.5 Changelog October 12th, 2023

;"!Counter2" is now entirely dependent on "!Counter." 
;From initial tests on Mednafen Supafaust it appears that I've finally put to bed
;the trouble with the Message counter being corrupted from save files. 

;This requires a fair bit of study to get the most out of the resource. 

;Labels more cleanly organized from studying the Disassembly of JAM's Messenger patch,
;and comparing that against P.JBoy's Bank Logs.  

lorom

;--------------------------------Defines---------------------------------------------

!89Free = $899100		  ;Freespace for Graphics
!84Free = $84F6B0		  ;Freespace for PLM
!84MainCode = !84Free+$20 ;Location for the PLM Instruction List
!PLM_Number = #$000A      ;Total number of PLMs to acquire
!Event = #$0016		      ;Event triggered when all artifacts are collected
!Message1 = $20		      ;First message displayed when collecting each PLM
!StartingNumber = #$0020  
;Message value stored to RAM once, Deliberately 1 less than message 21
;because it increases to a new target number every time the item is collected.


!SafetyNumber = !StartingNumber-#$0001   
;Deliberately 1 less than !StartingNumber for proper branching


!Counter = $7ED8F0        
;SRAM space for PLM counter. Each PLM adds 1 to this counter.


!Counter2 = !Counter+!StartingNumber 			
;Previous Values that only caused problems ($7ED8F4 ;$7ED8F2 ;$7E09F2)  		  
;Math formula entirely dependent on one Counter in RAM, 
;Adds whatever is in the first counter to the Starting Number.

;In the past, I had a lot of problems having two counters at work. 
;The PLMs would be collected, but weird things would happen to the Message counter when loading a new save file.
;This eliminates that tomfoolery.

;----------------------------------GFX-----------------------------------------------

org !89Free

incbin C:\CustomPLMGrafx.bin


;-----------------------------PLM Setup------------------------------------------------

org !84Free

dw $EE64 
dw InstList 

;-----------------------------PLM Main Code--------------------------------------------

org !84MainCode						

InstList:

dw $8764,$9100
db $01,$01,$01,$01,$01,$01,$01,$01 	;load PLM Item GFX

dw $887C,.ArgumentSet 						;Go to End if the room argument is set, (bottom row)
dw $8A24,.LinkInstruction 					;Link instruction to Pickup
dw $86C1,$DF89 								;Pre-instruction - go to link instruction if triggered

.Loop1							    
dw $E04F	   								;Draw frame 0; 
dw $E067	   								;Draw frame 1
dw $8724,.Loop1  				    		;Go to beginning of loop1

.LinkInstruction 							;Link Instruction
dw $8899 	   			    				;Set the room argument
dw $8BDD
db $02		   								;Clear music queue and queue item fanfare music track
dw .SMCounter

.ArgumentSet
dw $8724,$DFA9

.SMCounter
  LDA #$0020							;Display Message
  JSR $858080
  LDA !Counter2				;Gets the ball rolling
  CMP !SafetyNumber			;Safety Number is 1 less than "starting number" for proper branching		 
  BCS .DisplayMessage		;Once the ".TheFirstOne" routine does its thing, this branches to ".DisplayMessage" going forward. 

.TheFirstOne
  LDA !StartingNumber		;This has to be done here in this way. 
  STA !Counter2

.DisplayMessage
  LDA !Counter2
  INC A 
  STA !Counter2
  JSL $858080
  STZ $07DF

.NextStep  
  LDA !Counter 				;unused part of RAM, cleared on a new file.
  INC A
  STA !Counter
  CMP !PLM_Number			;!PLM_Number being #$000A, once you get ten of them it can proceed to the Event. 
  BNE ..Event
  JSR .End

..Event
  LDA !Event
  JSL $8081FA

;Earthquake
  LDA #$0006
  STA $183E
  LDA #$0046 
  STA $1840
  LDA #$0046
  JSL $8090CB
  
.End 
RTS

;---------------------------------------------------------------------------------------


